// pmpref.h

// Header file for PM Preference

// Todd Fincannon
// BIX: tfincannon
// CIS: 70526,1742
// Usenet: tlf@well.sf.ca.us  {ucbvax,apple,hplabs,pacbell}!well!tlf

// Revision log:
// 1.00 |  3 Apr 90 | initial release


// Resource ID for the menu, icon, accelerator table, and text resources

#define ID_RESOURCE     1

// Submenu identifiers

#define IDM_PREFMENU    0x100
#define IDM_HELPMENU    0x200

// Preference menu item identifiers

#define IDM_RESTORE     0x101
#define IDM_UNDO        0x102
#define IDM_SAVE        0x103
#define IDM_SAVEAS      0x104
#define IDM_DELETE      0x105
#define IDM_EXIT        0x106

// Help menu item identifiers

#define IDM_HELP        0x201
#define IDM_ABOUT       0x202

// Preference/Restore dialog box control identifiers

#define IDD_RESTORE     0x100
#define IDD_PREFLIST    0x101
#define IDD_PERMANENT   0x102
#define IDD_ORIGINAL    0x103

// Preference/Save As dialog box control identifiers

#define IDD_SAVEAS      0x200
#define IDD_EDITSAVE    0x201

// Preference/Delete dialog box control identifiers

#define IDD_DELETE      0x300
#define IDD_DELETELIST  0x301

// Help/About dialog box control identifier

#define IDD_ABOUT       0x400

// Text custom resource identifier

#define IDT_TEXT        0x400

// Text resource identifiers
// These are the same as the menu subtopic identifier that will
// trigger their display in the help hook.

#define IDT_PREFMENU    IDM_PREFMENU
#define IDT_RESTORE     IDM_RESTORE
#define IDT_UNDO        IDM_UNDO
#define IDT_SAVE        IDM_SAVE
#define IDT_SAVEAS      IDM_SAVEAS
#define IDT_DELETE      IDM_DELETE
#define IDT_EXIT        IDM_EXIT

#define IDT_HELPMENU    IDM_HELPMENU
#define IDT_HELP        IDM_HELP
#define IDT_ABOUT       IDM_ABOUT

// We allocate memory for PREF_ALLOC preferences at a time.

#define PREF_ALLOC      32

// Preferences are stored in this file.

#define PREF_FILE       "pmpref.ini"

// PREFINDEX data types are indicated by these constants.

#define PI_COLOR        0
#define PI_VALUE        1

// Logical color table indices for help window colors

#define CLR_HELPBACKGROUND    (CLR_BACKGROUND)
#define CLR_HELPTEXT          (CLR_HELPBACKGROUND + 1)
#define CLR_HELPHILITE        (CLR_HELPBACKGROUND + 2)

// Additional system colors for OS/2 1.2

#ifndef SYSCLR_BUTTONLIGHT

#define SYSCLR_BUTTONLIGHT           (-41L)
#define SYSCLR_BUTTONMIDDLE          (-40L)
#define SYSCLR_BUTTONDARK            (-39L)
#define SYSCLR_BUTTONDEFAULT         (-38L)
#define SYSCLR_TITLEBOTTOM           (-37L)
#define SYSCLR_SHADOW                (-36L)
#define SYSCLR_ICONTEXT              (-35L)
#define SYSCLR_DIALOGBACKGROUND      (-34L)
#define SYSCLR_HILITEFOREGROUND      (-33L)
#define SYSCLR_HILITEBACKGROUND      (-32L)
#define SYSCLR_INACTIVETITLETEXTBGND (-31L)
#define SYSCLR_ACTIVETITLETEXTBGND   (-30L)
#define SYSCLR_INACTIVETITLETEXT     (-29L)
#define SYSCLR_ACTIVETITLETEXT       (-28L)
#define SYSCLR_OUTPUTTEXT            (-27L)

#endif

// Additional system value for OS/2 1.2

#ifndef SV_TASKLISTMOUSEACCESS
#define SV_TASKLISTMOUSEACCESS   67
#endif

// User-defined messages

#define WM_CHANGEHELPTEXT  WM_USER

// Miscellaneous

#define MAX_NAME_SIZE   100
#define NUM_TEXTLINES   128
#define NUM_PRINT_CHARS ('~'-' '+1)
#define EOS             ((char) 0)
#define EOF_CHAR        '\x1a'
#define ESC_CHAR        '\x1b'

// The PREF structure holds all PM preference settings.  We include
// extra space for the new settings in OS/2 1.2.  These are set to
// OS/2 1.2 default values when PM Preference runs under OS/2 1.1.

typedef struct {
   LONG alColor [32];
   LONG alValue [6];
   CHAR szPrefName [MAX_NAME_SIZE];
} PREF;

typedef PREF FAR *PPREF;

typedef struct {
   CHAR szKeyName [21];
   USHORT usType;
   USHORT iValue;
   LONG lSysConst;
} PREFINDEX;

// The TEXTLINE structure describes a display line.

typedef struct {
   PSZ szText;
   SHORT sLength;
} TEXTLINE;

// The WNDX macro converts a character value to an index in the
// alWidth character width array.  Out-of-range characters are
// mapped to the space character.

#define WNDX(ch) (isprint (ch) ? (ch - 0x20) : 0)
